from __future__ import with_statement
from es import tell,isbot,getUseridList,AddonInfo,ServerVar,msg,usermsg
from gamethread import queue,delayedname,cancelDelayed
from playerlib import getPlayer
from configobj import ConfigObj
from os.path import join,exists
from mutelib import getPlayer as getMPlayer

info = AddonInfo()
info["name"] = "Mute Sage"
info["basename"] = "mutesage"
info["version"] = "0.0.1"
info["author"] = "MiB"
info["url"] = "http://addons.eventscripts.com/addons/view/mutesagepython"
info["description"] = "Dead can't use voice chat."

config = ConfigObj(join(str(ServerVar("eventscripts_gamedir")),"cfg\eventscripts\mutesage\config.ini"))
roundtime = int(config["roundtime"])
voicechat = int(config["mutevc"])
textchat = int(config["mutetc"])


roundmute = 0

immunelist = set()

with open(join(str(ServerVar("eventscripts_gamedir")),"cfg\eventscripts\mutesage\immunelist.txt"),"r+") as fh:
     for line in fh.readlines():
         if not bool(line) or line.startswith("//"):
             continue
         immunelist.add(line)

mani_clients_path = join(str(ServerVar("eventscripts_gamedir")),"cfg\mani_admin_plugin\clients.txt")
if exists(mani_clients_path):
    from keyfile import Parse
    clients = Parse(mani_clients_path)
    for x in clients["clients.txt"]["players"]:
        if "flags" in clients["clients.txt"]["players"][x]:
            y = clients["clients.txt"]["players"][x]["flags"]
            if "Immunity" in y:
                z = y["Immunity"]
                if type(z) == list:
                    z = " ".join(z)
                if "msim" in z.split(" "):
                    immunelist.add(clients["clients.txt"]["players"][x]["steam"])

def mutevaron():
    global roundmute
    if roundtime:
        roundmute = 1
    else:
        roundmute = 0

def mute(userid,msg=1):
    player = getMPlayer(userid)
    if voicechat:
        player.muteVoice()
    if textchat:
        player.muteText()
    if msg:
        if voicechat and not textchat:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour voicechat has been muted.")
        elif not voicechat and textchat:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour text has been muted.")
        else:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour have been completely muted.")

def unmute(userid,msg=1):
    player = getMPlayer(userid)
    if voicechat:
        player.unmuteVoice()
    if textchat:
        player.unmuteText()
    if msg:
        if voicechat and not textchat:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour voicechat has been unmuted.")
        elif not voicechat and textchat:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour text has been unmuted.")
        else:
            tell(userid,"#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultYour have been completely unmuted.")  

def panel(userid,text):
    usermsg("create","panel","KeyHintText")
    usermsg("write","byte","panel",1)
    usermsg("write","string","panel",text)
    usermsg("send","panel",userid)
    usermsg("delete","panel")

def rt(ax):
    global roundmute
    if ax:
        roundmute = 1
        for userid in getUseridList():
            player = getPlayer(userid)
            if player.team != 2 or player.isdead or player.steamid in immunelist:
                continue
            panel(userid,"________________\n\nRound Start Mute: %s\n________________"%ax)
            mute(userid,0)
        delayedname(1,"roundtime",rt,(ax - 1))
    else:
        roundmute = 0
        for userid in getUseridList():
            player = getPlayer(userid)
            if player.team != 2 or player.isdead or player.steamid in immunelist:
                continue
            panel(userid,"")
            unmute(userid,0)

def load():
    ServerVar("mute_sage_version",info["version"],"Mute Sage's public variable version.").makepublic()

def unload():
    cancelDelayed("roundtime")

def round_start(ev):
    if roundtime:
        queue(msg("#multi","#lightgreen|#greenMute Sage#lightgreen| #defaultTerrorists are muted for %s seconds after round start."%roundtime))
        cancelDelayed("roundtime")
        rt(roundtime)

def es_map_start(ev):
    mutevaron()

def round_end(ev):
    mutevaron()

def player_spawn(ev):
    u = ev["userid"]
    if isbot(u) or ev["es_steamid"] in immunelist:
        return
    if int(ev["es_userteam"]) > 1:
        if roundmute:
            mute(u)
        else:
            unmute(u)
    else:
        mute(u)

def player_death(ev):
    u = ev["userid"]
    if isbot(u) or ev["es_steamid"] in immunelist:
        return
    mute(u)
